gol_largeur = 0
gol_hauteur = 0
gol_grille = {}

function gol_nouveau(largeur, hauteur)
    gol_largeur = largeur
    gol_hauteur = hauteur
    for l = 1, gol_hauteur do
        gol_grille[l] = {}
        for c = 1, gol_largeur do
            gol_grille[l][c] = 0
        end
    end
end

function gol_random()
    for l = 1, gol_hauteur do
        for c = 1, gol_largeur do
            if love.math.random(10) == 1 then
                gol_grille[l][c] = 1
            end
        end
    end
end

function gol_cell(l,c)
    if l >= 1 and c >= 1 and l <= gol_hauteur and c <= gol_largeur then
        return gol_grille[l][c]
    else
        return 0
    end
end

function gol_voisin(l,c)
    local nb_voisins = 0
    nb_voisins = nb_voisins + gol_cell(l-1,c-1)
    nb_voisins = nb_voisins + gol_cell(l-1,c)
    nb_voisins = nb_voisins + gol_cell(l-1,c+1)
    nb_voisins = nb_voisins + gol_cell(l,c-1)
    nb_voisins = nb_voisins + gol_cell(l,c+1)
    nb_voisins = nb_voisins + gol_cell(l+1,c-1)
    nb_voisins = nb_voisins + gol_cell(l+1,c)
    nb_voisins = nb_voisins + gol_cell(l+1,c+1)
    return nb_voisins
end

function gol_life()
    local new_grille = {}
    local nbSand = 0
    for l = 1, gol_hauteur do
        if new_grille[l] == nil then new_grille[l] = {} end
        for c = 1, gol_largeur do
            local cell = gol_grille[l][c]
            if cell == 1 then
                nbSand = nbSand + 1
                -- La cellule peut tomber vers le bas
                if l < gol_hauteur and gol_grille[l+1][c] == 0 then
                    if new_grille[l+1] == nil then new_grille[l+1] = {} end
                    new_grille[l][c] = 0
                    new_grille[l+1][c] = 1
                elseif l < gol_hauteur and gol_grille[l+1][c+1] == 0 then
                    if new_grille[l+1] == nil then new_grille[l+1] = {} end
                    new_grille[l][c] = 0
                    new_grille[l+1][c+1] = 1
                elseif l < gol_hauteur and gol_grille[l+1][c-1] == 0 then
                    if new_grille[l+1] == nil then new_grille[l+1] = {} end
                    new_grille[l][c] = 0
                    new_grille[l+1][c-1] = 1
                else
                    new_grille[l][c] = 1
                end
            else
                -- Cette condition oubliée m'a fait perdre 15 mn !
                if new_grille[l][c] == nil then
                    new_grille[l][c] = 0
                end
            end
        end
    end
    gol_grille = new_grille
end