io.stdout:setvbuf('no')
if arg[#arg] == "-debug" then require("mobdebug").start() end

-- Empèche Love de filtrer les contours des images quand elles sont redimentionnées
-- Indispensable pour du pixel art
love.graphics.setDefaultFilter("nearest")

-- Cette ligne permet de déboguer pas à pas dans ZeroBraneStudio
if arg[#arg] == "-debug" then require("mobdebug").start() end

require("GOL")

local taille_cell
local pause = true

function love.load()

    largeurEcran = love.graphics.getWidth()
    hauteurEcran = love.graphics.getHeight()

    gol_nouveau(160,120)
    --gol_nouveau(largeurEcran/2, hauteurEcran/2)
    gol_random()

    local taille_cell_largeur = largeurEcran / gol_largeur
    local taille_cell_hauteur = hauteurEcran / gol_hauteur
    if taille_cell_largeur * gol_hauteur > hauteurEcran then
        taille_cell = taille_cell_hauteur
    else
        taille_cell = taille_cell_largeur
    end
end

function love.update(dt)
    if pause == false then
        gol_life()
    end

    if love.mouse.isDown(1) then
        local c = math.floor(love.mouse.getX() / taille_cell) + 1
        local l = math.floor(love.mouse.getY() / taille_cell) + 1
        if l >= 1 and c >= 1 and l <= gol_hauteur and c <= gol_largeur then
            gol_grille[l][c] = 1
        end
    end
end

function love.draw()    
    for l=1, gol_hauteur do
        for c=1, gol_largeur do
            if gol_grille[l][c] == 1 then
                love.graphics.rectangle("fill", (c-1) * taille_cell, (l-1) * taille_cell, taille_cell, taille_cell)
            end
        end
    end
    love.graphics.print(love.timer.getFPS())
end

function love.keypressed(key)
    print(key)
    if key == "escape" then
        love.event.quit()
    end
    if key == "r" then
        gol_random()
    end
    if key == "space" then
        pause = not pause
    end
    if key == "right" then
        gol_life()
    end
end
